
    create table if not exists Attachment (
        id bigint generated by default as identity,
        accesstype integer,
        attachedat timestamp,
        attachmentcontentid bigint not null,
        contenttype varchar(255),
        name varchar(255),
        attachment_size integer,
        attachedby_id varchar(255),
        TaskData_Attachments_Id bigint,
        primary key (id)
    );

    create table if not exists BAMTaskSummary (
        pk bigint generated by default as identity,
        createddate timestamp,
        duration bigint,
        enddate timestamp,
        processinstanceid bigint not null,
        startdate timestamp,
        status varchar(255),
        taskid bigint not null,
        taskname varchar(255),
        userid varchar(255),
        primary key (pk)
    );

    create table if not exists BooleanExpression (
        id bigint generated by default as identity,
        expression clob,
        type varchar(255),
        Escalation_Constraints_Id bigint,
        primary key (id)
    );

    create table if not exists Content (
        id bigint generated by default as identity,
        content blob,
        primary key (id)
    );

    create table if not exists ContextMappingInfo (
        mappingid bigint generated by default as identity,
        CONTEXT_ID varchar(255) not null,
        KSESSION_ID integer not null,
        OPTLOCK integer,
        primary key (mappingid)
    );

    create table if not exists CorrelationKeyInfo (
        keyId bigint generated by default as identity,
        name varchar(255),
        processinstanceid bigint not null,
        OPTLOCK integer,
        primary key (keyId)
    );

    create table if not exists CorrelationPropertyInfo (
        propertyId bigint generated by default as identity,
        name varchar(255),
        value varchar(255),
        OPTLOCK integer,
        correlationkey_keyId bigint,
        primary key (propertyId)
    );

    create table if not exists Deadline (
        id bigint generated by default as identity,
        deadline_date timestamp,
        escalated smallint,
        Deadlines_StartDeadLine_Id bigint,
        Deadlines_EndDeadLine_Id bigint,
        primary key (id)
    );

    create table if not exists Delegation_delegates (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists Escalation (
        id bigint generated by default as identity,
        name varchar(255),
        Deadline_Escalation_Id bigint,
        primary key (id)
    );

    create table if not exists EventTypes (
        InstanceId bigint not null,
        element varchar(255)
    );

    create table if not exists I18NText (
        id bigint generated by default as identity,
        language varchar(255),
        shorttext varchar(255),
        text clob,
        Task_Subjects_Id bigint,
        Task_Names_Id bigint,
        Task_Descriptions_Id bigint,
        Reassignment_Documentation_Id bigint,
        Notification_Subjects_Id bigint,
        Notification_Names_Id bigint,
        Notification_Documentation_Id bigint,
        Notification_Descriptions_Id bigint,
        Deadline_Documentation_Id bigint,
        primary key (id)
    );

    create table if not exists NodeInstanceLog (
        id bigint generated by default as identity,
        connection varchar(255),
        log_date timestamp,
        externalid varchar(255),
        nodeid varchar(255),
        nodeinstanceid varchar(255),
        nodename varchar(255),
        nodetype varchar(255),
        processid varchar(255),
        processinstanceid bigint not null,
        type integer not null,
        workitemid bigint,
        primary key (id)
    );

    create table if not exists Notification (
        DTYPE varchar(31) not null,
        id bigint generated by default as identity,
        priority integer not null,
        Escalation_Notifications_Id bigint,
        primary key (id)
    );

    create table if not exists Notification_BAs (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists Notification_Recipients (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists Notification_email_header (
        Notification_id bigint not null,
        emailheaders_id bigint not null,
        emailheaders_mapkey_key_mapkey varchar(255) not null,
        primary key (Notification_id, emailheaders_mapkey_key_mapkey)
    );

    create table if not exists OrganizationalEntity (
        DTYPE varchar(31) not null,
        id varchar(255) not null,
        primary key (id)
    );

    create table if not exists PeopleAssignments_BAs (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists PeopleAssignments_ExclOwners (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists PeopleAssignments_PotOwners (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists PeopleAssignments_Recipients (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists PeopleAssignments_Stakeholders (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists ProcessInstanceInfo (
        InstanceId bigint generated by default as identity,
        lastmodificationdate timestamp,
        lastreaddate timestamp,
        processid varchar(255),
        processinstancebytearray blob,
        startdate timestamp,
        state integer not null,
        OPTLOCK integer,
        primary key (InstanceId)
    );

    create table if not exists ProcessInstanceLog (
        id bigint generated by default as identity,
        duration bigint,
        end_date timestamp,
        externalid varchar(255),
        user_identity varchar(255),
        outcome varchar(255),
        parentprocessinstanceid bigint,
        processid varchar(255),
        processinstanceid bigint not null,
        processname varchar(255),
        processversion varchar(255),
        start_date timestamp,
        status integer,
        primary key (id)
    );

    create table if not exists Reassignment (
        id bigint generated by default as identity,
        Escalation_Reassignments_Id bigint,
        primary key (id)
    );

    create table if not exists Reassignment_potentialOwners (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    create table if not exists SessionInfo (
        id integer generated by default as identity,
        lastmodificationdate timestamp,
        rulesbytearray blob,
        startdate timestamp,
        OPTLOCK integer,
        primary key (id)
    );

    create table if not exists Task (
        id bigint generated by default as identity,
        archived smallint,
        delegation_allowedtodelegate varchar(255),
        formname varchar(255),
        priority integer not null,
        subtaskstrategy varchar(255),
        taskdata_activationtime timestamp,
        taskdata_createdon timestamp,
        taskdata_deploymentid varchar(255),
        taskdata_documentaccesstype integer,
        taskdata_documentcontentid bigint not null,
        taskdata_documenttype varchar(255),
        taskdata_expirationtime timestamp,
        taskdata_faultaccesstype integer,
        taskdata_faultcontentid bigint not null,
        taskdata_faultname varchar(255),
        taskdata_faulttype varchar(255),
        taskdata_outputaccesstype integer,
        taskdata_outputcontentid bigint not null,
        taskdata_outputtype varchar(255),
        taskdata_parentid bigint not null,
        taskdata_previousstatus integer,
        taskdata_processid varchar(255),
        taskdata_processinstanceid bigint not null,
        taskdata_processsessionid integer not null,
        taskdata_skipable boolean not null,
        taskdata_status varchar(255),
        taskdata_workitemid bigint not null,
        tasktype varchar(255),
        OPTLOCK integer,
        peopl_assign_taskinitiator_id varchar(255),
        taskdata_actualowner_id varchar(255),
        taskdata_createdby_id varchar(255),
        primary key (id)
    );

    create table if not exists TaskEvent (
        id bigint generated by default as identity,
        logtime timestamp,
        taskid bigint,
        type varchar(255),
        userid varchar(255),
        primary key (id)
    );

    create table if not exists VariableInstanceLog (
        id bigint generated by default as identity,
        log_date timestamp,
        externalid varchar(255),
        oldvalue varchar(255),
        processid varchar(255),
        processinstanceid bigint not null,
        value varchar(255),
        variableid varchar(255),
        variableinstanceid varchar(255),
        primary key (id)
    );

    create table if not exists WorkItemInfo (
        workitemid bigint generated by default as identity,
        creationdate timestamp,
        name varchar(255),
        processinstanceid bigint not null,
        state bigint not null,
        OPTLOCK integer,
        workitembytearray blob,
        primary key (workitemid)
    );

    create table if not exists email_header (
        id bigint generated by default as identity,
        body clob,
        fromAddress varchar(255),
        language varchar(255),
        replyToAddress varchar(255),
        subject varchar(255),
        primary key (id)
    );

    create table if not exists task_comment (
        id bigint generated by default as identity,
        addedat timestamp,
        text clob,
        addedby_id varchar(255),
        TaskData_Comments_Id bigint,
        primary key (id)
    );

    call execute_if_exists('alter table Attachment 
        add constraint FK_9jaco4irrkskr5phh97x2fe9h 
        foreign key (attachedby_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table Attachment 
        add constraint FK_hqupx569krp0f0sgu9kh87513 
        foreign key (TaskData_Attachments_Id) 
        references Task');

    call execute_if_exists('alter table BooleanExpression 
        add constraint FK_394nf2qoc0k9ok6omgd6jtpso 
        foreign key (Escalation_Constraints_Id) 
        references Escalation');

    call execute_if_exists('alter table CorrelationPropertyInfo 
        add constraint FK_1mgvtkn3h0bxu2fd657apkvxs 
        foreign key (correlationkey_keyId) 
        references CorrelationKeyInfo');

    call execute_if_exists('alter table Deadline 
        add constraint FK_68w742sge00vco2cq3jhbvmgx 
        foreign key (Deadlines_StartDeadLine_Id) 
        references Task');

    call execute_if_exists('alter table Deadline 
        add constraint FK_euoohoelbqvv94d8a8rcg8s5n 
        foreign key (Deadlines_EndDeadLine_Id) 
        references Task');

    call execute_if_exists('alter table Delegation_delegates 
        add constraint FK_gn7ula51sk55wj1o1m57guqxb 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table Delegation_delegates 
        add constraint FK_fajq6kossbsqwr3opkrctxei3 
        foreign key (task_id) 
        references Task');

    call execute_if_exists('alter table Escalation 
        add constraint FK_ay2gd4fvl9yaapviyxudwuvfg 
        foreign key (Deadline_Escalation_Id) 
        references Deadline');

    call execute_if_exists('alter table EventTypes 
        add constraint FK_nrecj4617iwxlc65ij6m7lsl1 
        foreign key (InstanceId) 
        references ProcessInstanceInfo');

    call execute_if_exists('alter table I18NText 
        add constraint FK_k16jpgrh67ti9uedf6konsu1p 
        foreign key (Task_Subjects_Id) 
        references Task');

    call execute_if_exists('alter table I18NText 
        add constraint FK_fd9uk6hemv2dx1ojovo7ms3vp 
        foreign key (Task_Names_Id) 
        references Task');

    call execute_if_exists('alter table I18NText 
        add constraint FK_4eyfp69ucrron2hr7qx4np2fp 
        foreign key (Task_Descriptions_Id) 
        references Task');

    call execute_if_exists('alter table I18NText 
        add constraint FK_pqarjvvnwfjpeyb87yd7m0bfi 
        foreign key (Reassignment_Documentation_Id) 
        references Reassignment');

    call execute_if_exists('alter table I18NText 
        add constraint FK_o84rkh69r47ti8uv4eyj7bmo2 
        foreign key (Notification_Subjects_Id) 
        references Notification');

    call execute_if_exists('alter table I18NText 
        add constraint FK_g1trxri8w64enudw2t1qahhk5 
        foreign key (Notification_Names_Id) 
        references Notification');

    call execute_if_exists('alter table I18NText 
        add constraint FK_qoce92c70adem3ccb3i7lec8x 
        foreign key (Notification_Documentation_Id) 
        references Notification');

    call execute_if_exists('alter table I18NText 
        add constraint FK_bw8vmpekejxt1ei2ge26gdsry 
        foreign key (Notification_Descriptions_Id) 
        references Notification');

    call execute_if_exists('alter table I18NText 
        add constraint FK_21qvifarxsvuxeaw5sxwh473w 
        foreign key (Deadline_Documentation_Id) 
        references Deadline');

    call execute_if_exists('alter table Notification 
        add constraint FK_bdbeml3768go5im41cgfpyso9 
        foreign key (Escalation_Notifications_Id) 
        references Escalation');

    call execute_if_exists('alter table Notification_BAs 
        add constraint FK_mfbsnbrhth4rjhqc2ud338s4i 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table Notification_BAs 
        add constraint FK_fc0uuy76t2bvxaxqysoo8xts7 
        foreign key (task_id) 
        references Notification');

    call execute_if_exists('alter table Notification_Recipients 
        add constraint FK_blf9jsrumtrthdaqnpwxt25eu 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table Notification_Recipients 
        add constraint FK_3l244pj8sh78vtn9imaymrg47 
        foreign key (task_id) 
        references Notification');

    call execute_if_exists('alter table Notification_email_header 
        add constraint UK_25vn3oqfsiwwda26w9uiprrwe unique (emailheaders_id)');

    call execute_if_exists('alter table Notification_email_header 
        add constraint FK_25vn3oqfsiwwda26w9uiprrwe 
        foreign key (emailheaders_id) 
        references email_header');

    call execute_if_exists('alter table Notification_email_header 
        add constraint FK_eth4nvxn21fk1vnju85vkjrai 
        foreign key (Notification_id) 
        references Notification');

    call execute_if_exists('alter table PeopleAssignments_BAs 
        add constraint FK_t38xbkrq6cppifnxequhvjsl2 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table PeopleAssignments_BAs 
        add constraint FK_omjg5qh7uv8e9bolbaq7hv6oh 
        foreign key (task_id) 
        references Task');

    call execute_if_exists('alter table PeopleAssignments_ExclOwners 
        add constraint FK_pth28a73rj6bxtlfc69kmqo0a 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table PeopleAssignments_ExclOwners 
        add constraint FK_b8owuxfrdng050ugpk0pdowa7 
        foreign key (task_id) 
        references Task');

    call execute_if_exists('alter table PeopleAssignments_PotOwners 
        add constraint FK_tee3ftir7xs6eo3fdvi3xw026 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table PeopleAssignments_PotOwners 
        add constraint FK_4dv2oji7pr35ru0w45trix02x 
        foreign key (task_id) 
        references Task');

    call execute_if_exists('alter table PeopleAssignments_Recipients 
        add constraint FK_4g7y3wx6gnokf6vycgpxs83d6 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table PeopleAssignments_Recipients 
        add constraint FK_enhk831fghf6akjilfn58okl4 
        foreign key (task_id) 
        references Task');

    call execute_if_exists('alter table PeopleAssignments_Stakeholders 
        add constraint FK_met63inaep6cq4ofb3nnxi4tm 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table PeopleAssignments_Stakeholders 
        add constraint FK_4bh3ay74x6ql9usunubttfdf1 
        foreign key (task_id) 
        references Task');

    call execute_if_exists('alter table Reassignment 
        add constraint FK_pnpeue9hs6kx2ep0sp16b6kfd 
        foreign key (Escalation_Reassignments_Id) 
        references Escalation');

    call execute_if_exists('alter table Reassignment_potentialOwners 
        add constraint FK_8frl6la7tgparlnukhp8xmody 
        foreign key (entity_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table Reassignment_potentialOwners 
        add constraint FK_qbega5ncu6b9yigwlw55aeijn 
        foreign key (task_id) 
        references Reassignment');

    call execute_if_exists('alter table Task 
        add constraint FK_7hos7h1ft5wygyru9vm2mtp6b 
        foreign key (peopl_assign_taskinitiator_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table Task 
        add constraint FK_iu0slqdkjbb9mvikrns8mvqcg 
        foreign key (taskdata_actualowner_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table Task 
        add constraint FK_tek6betmy2fl0bnwrsx9a4fi9 
        foreign key (taskdata_createdby_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table task_comment 
        add constraint FK_fencp0rt8gae730n7621vqjre 
        foreign key (addedby_id) 
        references OrganizationalEntity');

    call execute_if_exists('alter table task_comment 
        add constraint FK_1ws9jdmhtey6mxu7jb0r0ufvs 
        foreign key (TaskData_Comments_Id) 
        references Task');