
    select execute_if_not_exists('create table Attachment (
        id int8 not null,
        accesstype int4,
        attachedat timestamp,
        attachmentcontentid int8 not null,
        contenttype varchar(255),
        name varchar(255),
        attachment_size int4,
        attachedby_id varchar(255),
        TaskData_Attachments_Id int8,
        primary key (id)
    )');

    select execute_if_not_exists('create table BAMTaskSummary (
        pk int8 not null,
        createddate timestamp,
        duration int8,
        enddate timestamp,
        processinstanceid int8 not null,
        startdate timestamp,
        status varchar(255),
        taskid int8 not null,
        taskname varchar(255),
        userid varchar(255),
        primary key (pk)
    )');

    select execute_if_not_exists('create table BooleanExpression (
        id int8 not null,
        expression text,
        type varchar(255),
        Escalation_Constraints_Id int8,
        primary key (id)
    )');

    select execute_if_not_exists('create table Content (
        id int8 not null,
        content oid,
        primary key (id)
    )');

    select execute_if_not_exists('create table ContextMappingInfo (
        mappingid int8 not null,
        CONTEXT_ID varchar(255) not null,
        KSESSION_ID int4 not null,
        OPTLOCK int4,
        primary key (mappingid)
    )');

    select execute_if_not_exists('create table CorrelationKeyInfo (
        keyId int8 not null,
        name varchar(255),
        processinstanceid int8 not null,
        OPTLOCK int4,
        primary key (keyId)
    )');

    select execute_if_not_exists('create table CorrelationPropertyInfo (
        propertyId int8 not null,
        name varchar(255),
        value varchar(255),
        OPTLOCK int4,
        correlationkey_keyId int8,
        primary key (propertyId)
    )');

    select execute_if_not_exists('create table Deadline (
        id int8 not null,
        deadline_date timestamp,
        escalated int2,
        Deadlines_StartDeadLine_Id int8,
        Deadlines_EndDeadLine_Id int8,
        primary key (id)
    )');

    select execute_if_not_exists('create table Delegation_delegates (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table Escalation (
        id int8 not null,
        name varchar(255),
        Deadline_Escalation_Id int8,
        primary key (id)
    )');

    select execute_if_not_exists('create table EventTypes (
        InstanceId int8 not null,
        element varchar(255)
    )');

    select execute_if_not_exists('create table I18NText (
        id int8 not null,
        language varchar(255),
        shorttext varchar(255),
        text text,
        Task_Subjects_Id int8,
        Task_Names_Id int8,
        Task_Descriptions_Id int8,
        Reassignment_Documentation_Id int8,
        Notification_Subjects_Id int8,
        Notification_Names_Id int8,
        Notification_Documentation_Id int8,
        Notification_Descriptions_Id int8,
        Deadline_Documentation_Id int8,
        primary key (id)
    )');

    select execute_if_not_exists('create table NodeInstanceLog (
        id int8 not null,
        connection varchar(255),
        log_date timestamp,
        externalid varchar(255),
        nodeid varchar(255),
        nodeinstanceid varchar(255),
        nodename varchar(255),
        nodetype varchar(255),
        processid varchar(255),
        processinstanceid int8 not null,
        type int4 not null,
        workitemid int8,
        primary key (id)
    )');

    select execute_if_not_exists('create table Notification (
        DTYPE varchar(31) not null,
        id int8 not null,
        priority int4 not null,
        Escalation_Notifications_Id int8,
        primary key (id)
    )');

    select execute_if_not_exists('create table Notification_BAs (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table Notification_Recipients (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table Notification_email_header (
        Notification_id int8 not null,
        emailheaders_id int8 not null,
        emailheaders_mapkey_key_mapkey varchar(255) not null,
        primary key (Notification_id, emailheaders_mapkey_key_mapkey)
    )');

    select execute_if_not_exists('create table OrganizationalEntity (
        DTYPE varchar(31) not null,
        id varchar(255) not null,
        primary key (id)
    )');

    select execute_if_not_exists('create table PeopleAssignments_BAs (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table PeopleAssignments_ExclOwners (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table PeopleAssignments_PotOwners (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table PeopleAssignments_Recipients (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table PeopleAssignments_Stakeholders (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table ProcessInstanceInfo (
        InstanceId int8 not null,
        lastmodificationdate timestamp,
        lastreaddate timestamp,
        processid varchar(255),
        processinstancebytearray oid,
        startdate timestamp,
        state int4 not null,
        OPTLOCK int4,
        primary key (InstanceId)
    )');

    select execute_if_not_exists('create table ProcessInstanceLog (
        id int8 not null,
        duration int8,
        end_date timestamp,
        externalid varchar(255),
        user_identity varchar(255),
        outcome varchar(255),
        parentprocessinstanceid int8,
        processid varchar(255),
        processinstanceid int8 not null,
        processname varchar(255),
        processversion varchar(255),
        start_date timestamp,
        status int4,
        primary key (id)
    )');

    select execute_if_not_exists('create table Reassignment (
        id int8 not null,
        Escalation_Reassignments_Id int8,
        primary key (id)
    )');

    select execute_if_not_exists('create table Reassignment_potentialOwners (
        task_id int8 not null,
        entity_id varchar(255) not null
    )');

    select execute_if_not_exists('create table SessionInfo (
        id int4 not null,
        lastmodificationdate timestamp,
        rulesbytearray oid,
        startdate timestamp,
        OPTLOCK int4,
        primary key (id)
    )');

    select execute_if_not_exists('create table Task (
        id int8 not null,
        archived int2,
        delegation_allowedtodelegate varchar(255),
        formname varchar(255),
        priority int4 not null,
        subtaskstrategy varchar(255),
        taskdata_activationtime timestamp,
        taskdata_createdon timestamp,
        taskdata_deploymentid varchar(255),
        taskdata_documentaccesstype int4,
        taskdata_documentcontentid int8 not null,
        taskdata_documenttype varchar(255),
        taskdata_expirationtime timestamp,
        taskdata_faultaccesstype int4,
        taskdata_faultcontentid int8 not null,
        taskdata_faultname varchar(255),
        taskdata_faulttype varchar(255),
        taskdata_outputaccesstype int4,
        taskdata_outputcontentid int8 not null,
        taskdata_outputtype varchar(255),
        taskdata_parentid int8 not null,
        taskdata_previousstatus int4,
        taskdata_processid varchar(255),
        taskdata_processinstanceid int8 not null,
        taskdata_processsessionid int4 not null,
        taskdata_skipable boolean not null,
        taskdata_status varchar(255),
        taskdata_workitemid int8 not null,
        tasktype varchar(255),
        OPTLOCK int4,
        peopl_assign_taskinitiator_id varchar(255),
        taskdata_actualowner_id varchar(255),
        taskdata_createdby_id varchar(255),
        primary key (id)
    )');

    select execute_if_not_exists('create table TaskEvent (
        id int8 not null,
        logtime timestamp,
        taskid int8,
        type varchar(255),
        userid varchar(255),
        primary key (id)
    )');

    select execute_if_not_exists('create table VariableInstanceLog (
        id int8 not null,
        log_date timestamp,
        externalid varchar(255),
        oldvalue varchar(255),
        processid varchar(255),
        processinstanceid int8 not null,
        value varchar(255),
        variableid varchar(255),
        variableinstanceid varchar(255),
        primary key (id)
    )');

    select execute_if_not_exists('create table WorkItemInfo (
        workitemid int8 not null,
        creationdate timestamp,
        name varchar(255),
        processinstanceid int8 not null,
        state int8 not null,
        OPTLOCK int4,
        workitembytearray oid,
        primary key (workitemid)
    )');

    select execute_if_not_exists('create table email_header (
        id int8 not null,
        body text,
        fromAddress varchar(255),
        language varchar(255),
        replyToAddress varchar(255),
        subject varchar(255),
        primary key (id)
    )');

    select execute_if_not_exists('create table task_comment (
        id int8 not null,
        addedat timestamp,
        text text,
        addedby_id varchar(255),
        TaskData_Comments_Id int8,
        primary key (id)
    )');

    select execute_if_exists('alter table Attachment 
        add constraint FK_9jaco4irrkskr5phh97x2fe9h 
        foreign key (attachedby_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table Attachment 
        add constraint FK_hqupx569krp0f0sgu9kh87513 
        foreign key (TaskData_Attachments_Id) 
        references Task');

    select execute_if_exists('alter table BooleanExpression 
        add constraint FK_394nf2qoc0k9ok6omgd6jtpso 
        foreign key (Escalation_Constraints_Id) 
        references Escalation');

    select execute_if_exists('alter table CorrelationPropertyInfo 
        add constraint FK_1mgvtkn3h0bxu2fd657apkvxs 
        foreign key (correlationkey_keyId) 
        references CorrelationKeyInfo');

    select execute_if_exists('alter table Deadline 
        add constraint FK_68w742sge00vco2cq3jhbvmgx 
        foreign key (Deadlines_StartDeadLine_Id) 
        references Task');

    select execute_if_exists('alter table Deadline 
        add constraint FK_euoohoelbqvv94d8a8rcg8s5n 
        foreign key (Deadlines_EndDeadLine_Id) 
        references Task');

    select execute_if_exists('alter table Delegation_delegates 
        add constraint FK_gn7ula51sk55wj1o1m57guqxb 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table Delegation_delegates 
        add constraint FK_fajq6kossbsqwr3opkrctxei3 
        foreign key (task_id) 
        references Task');

    select execute_if_exists('alter table Escalation 
        add constraint FK_ay2gd4fvl9yaapviyxudwuvfg 
        foreign key (Deadline_Escalation_Id) 
        references Deadline');

    select execute_if_exists('alter table EventTypes 
        add constraint FK_nrecj4617iwxlc65ij6m7lsl1 
        foreign key (InstanceId) 
        references ProcessInstanceInfo');

    select execute_if_exists('alter table I18NText 
        add constraint FK_k16jpgrh67ti9uedf6konsu1p 
        foreign key (Task_Subjects_Id) 
        references Task');

    select execute_if_exists('alter table I18NText 
        add constraint FK_fd9uk6hemv2dx1ojovo7ms3vp 
        foreign key (Task_Names_Id) 
        references Task');

    select execute_if_exists('alter table I18NText 
        add constraint FK_4eyfp69ucrron2hr7qx4np2fp 
        foreign key (Task_Descriptions_Id) 
        references Task');

    select execute_if_exists('alter table I18NText 
        add constraint FK_pqarjvvnwfjpeyb87yd7m0bfi 
        foreign key (Reassignment_Documentation_Id) 
        references Reassignment');

    select execute_if_exists('alter table I18NText 
        add constraint FK_o84rkh69r47ti8uv4eyj7bmo2 
        foreign key (Notification_Subjects_Id) 
        references Notification');

    select execute_if_exists('alter table I18NText 
        add constraint FK_g1trxri8w64enudw2t1qahhk5 
        foreign key (Notification_Names_Id) 
        references Notification');

    select execute_if_exists('alter table I18NText 
        add constraint FK_qoce92c70adem3ccb3i7lec8x 
        foreign key (Notification_Documentation_Id) 
        references Notification');

    select execute_if_exists('alter table I18NText 
        add constraint FK_bw8vmpekejxt1ei2ge26gdsry 
        foreign key (Notification_Descriptions_Id) 
        references Notification');

    select execute_if_exists('alter table I18NText 
        add constraint FK_21qvifarxsvuxeaw5sxwh473w 
        foreign key (Deadline_Documentation_Id) 
        references Deadline');

    select execute_if_exists('alter table Notification 
        add constraint FK_bdbeml3768go5im41cgfpyso9 
        foreign key (Escalation_Notifications_Id) 
        references Escalation');

    select execute_if_exists('alter table Notification_BAs 
        add constraint FK_mfbsnbrhth4rjhqc2ud338s4i 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table Notification_BAs 
        add constraint FK_fc0uuy76t2bvxaxqysoo8xts7 
        foreign key (task_id) 
        references Notification');

    select execute_if_exists('alter table Notification_Recipients 
        add constraint FK_blf9jsrumtrthdaqnpwxt25eu 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table Notification_Recipients 
        add constraint FK_3l244pj8sh78vtn9imaymrg47 
        foreign key (task_id) 
        references Notification');

    select execute_if_exists('alter table Notification_email_header 
        add constraint UK_25vn3oqfsiwwda26w9uiprrwe unique (emailheaders_id)');

    select execute_if_exists('alter table Notification_email_header 
        add constraint FK_25vn3oqfsiwwda26w9uiprrwe 
        foreign key (emailheaders_id) 
        references email_header');

    select execute_if_exists('alter table Notification_email_header 
        add constraint FK_eth4nvxn21fk1vnju85vkjrai 
        foreign key (Notification_id) 
        references Notification');

    select execute_if_exists('alter table PeopleAssignments_BAs 
        add constraint FK_t38xbkrq6cppifnxequhvjsl2 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table PeopleAssignments_BAs 
        add constraint FK_omjg5qh7uv8e9bolbaq7hv6oh 
        foreign key (task_id) 
        references Task');

    select execute_if_exists('alter table PeopleAssignments_ExclOwners 
        add constraint FK_pth28a73rj6bxtlfc69kmqo0a 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table PeopleAssignments_ExclOwners 
        add constraint FK_b8owuxfrdng050ugpk0pdowa7 
        foreign key (task_id) 
        references Task');

    select execute_if_exists('alter table PeopleAssignments_PotOwners 
        add constraint FK_tee3ftir7xs6eo3fdvi3xw026 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table PeopleAssignments_PotOwners 
        add constraint FK_4dv2oji7pr35ru0w45trix02x 
        foreign key (task_id) 
        references Task');

    select execute_if_exists('alter table PeopleAssignments_Recipients 
        add constraint FK_4g7y3wx6gnokf6vycgpxs83d6 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table PeopleAssignments_Recipients 
        add constraint FK_enhk831fghf6akjilfn58okl4 
        foreign key (task_id) 
        references Task');

    select execute_if_exists('alter table PeopleAssignments_Stakeholders 
        add constraint FK_met63inaep6cq4ofb3nnxi4tm 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table PeopleAssignments_Stakeholders 
        add constraint FK_4bh3ay74x6ql9usunubttfdf1 
        foreign key (task_id) 
        references Task');

    select execute_if_exists('alter table Reassignment 
        add constraint FK_pnpeue9hs6kx2ep0sp16b6kfd 
        foreign key (Escalation_Reassignments_Id) 
        references Escalation');

    select execute_if_exists('alter table Reassignment_potentialOwners 
        add constraint FK_8frl6la7tgparlnukhp8xmody 
        foreign key (entity_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table Reassignment_potentialOwners 
        add constraint FK_qbega5ncu6b9yigwlw55aeijn 
        foreign key (task_id) 
        references Reassignment');

    select execute_if_exists('alter table Task 
        add constraint FK_7hos7h1ft5wygyru9vm2mtp6b 
        foreign key (peopl_assign_taskinitiator_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table Task 
        add constraint FK_iu0slqdkjbb9mvikrns8mvqcg 
        foreign key (taskdata_actualowner_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table Task 
        add constraint FK_tek6betmy2fl0bnwrsx9a4fi9 
        foreign key (taskdata_createdby_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table task_comment 
        add constraint FK_fencp0rt8gae730n7621vqjre 
        foreign key (addedby_id) 
        references OrganizationalEntity');

    select execute_if_exists('alter table task_comment 
        add constraint FK_1ws9jdmhtey6mxu7jb0r0ufvs 
        foreign key (TaskData_Comments_Id) 
        references Task');

    select execute_if_not_exists('create sequence ATTACHMENT_ID_SEQ');

    select execute_if_not_exists('create sequence BAM_TASK_ID_SEQ');

    select execute_if_not_exists('create sequence BOOLEANEXPR_ID_SEQ');

    select execute_if_not_exists('create sequence COMMENT_ID_SEQ');

    select execute_if_not_exists('create sequence CONTENT_ID_SEQ');

    select execute_if_not_exists('create sequence CONTEXT_MAPPING_INFO_ID_SEQ');

    select execute_if_not_exists('create sequence CORRELATION_KEY_ID_SEQ');

    select execute_if_not_exists('create sequence CORRELATION_PROP_ID_SEQ');

    select execute_if_not_exists('create sequence DEADLINE_ID_SEQ');

    select execute_if_not_exists('create sequence EMAILNOTIFHEAD_ID_SEQ');

    select execute_if_not_exists('create sequence ESCALATION_ID_SEQ');

    select execute_if_not_exists('create sequence I18NTEXT_ID_SEQ');

    select execute_if_not_exists('create sequence NODE_INST_LOG_ID_SEQ');

    select execute_if_not_exists('create sequence NOTIFICATION_ID_SEQ');

    select execute_if_not_exists('create sequence PROCESS_INSTANCE_INFO_ID_SEQ');

    select execute_if_not_exists('create sequence PROC_INST_LOG_ID_SEQ');

    select execute_if_not_exists('create sequence REASSIGNMENT_ID_SEQ');

    select execute_if_not_exists('create sequence SESSIONINFO_ID_SEQ');

    select execute_if_not_exists('create sequence TASK_EVENT_ID_SEQ');

    select execute_if_not_exists('create sequence TASK_ID_SEQ');

    select execute_if_not_exists('create sequence VAR_INST_LOG_ID_SEQ');

    select execute_if_not_exists('create sequence WORKITEMINFO_ID_SEQ');