
    if object_id('Attachment', 'U') is null create table Attachment (
        id bigint identity not null,
        accesstype int,
        attachedat datetime2,
        attachmentcontentid bigint not null,
        contenttype varchar(255),
        name varchar(255),
        attachment_size int,
        attachedby_id varchar(255),
        TaskData_Attachments_Id bigint,
        primary key (id)
    );

    if object_id('BAMTaskSummary', 'U') is null create table BAMTaskSummary (
        pk bigint identity not null,
        createddate datetime2,
        duration bigint,
        enddate datetime2,
        processinstanceid bigint not null,
        startdate datetime2,
        status varchar(255),
        taskid bigint not null,
        taskname varchar(255),
        userid varchar(255),
        primary key (pk)
    );

    if object_id('BooleanExpression', 'U') is null create table BooleanExpression (
        id bigint identity not null,
        expression varchar(MAX),
        type varchar(255),
        Escalation_Constraints_Id bigint,
        primary key (id)
    );

    if object_id('Content', 'U') is null create table Content (
        id bigint identity not null,
        content varbinary(MAX),
        primary key (id)
    );

    if object_id('ContextMappingInfo', 'U') is null create table ContextMappingInfo (
        mappingid bigint identity not null,
        CONTEXT_ID varchar(255) not null,
        KSESSION_ID int not null,
        OPTLOCK int,
        primary key (mappingid)
    );

    if object_id('CorrelationKeyInfo', 'U') is null create table CorrelationKeyInfo (
        keyId bigint identity not null,
        name varchar(255),
        processinstanceid bigint not null,
        OPTLOCK int,
        primary key (keyId)
    );

    if object_id('CorrelationPropertyInfo', 'U') is null create table CorrelationPropertyInfo (
        propertyId bigint identity not null,
        name varchar(255),
        value varchar(255),
        OPTLOCK int,
        correlationkey_keyId bigint,
        primary key (propertyId)
    );

    if object_id('Deadline', 'U') is null create table Deadline (
        id bigint identity not null,
        deadline_date datetime2,
        escalated smallint,
        Deadlines_StartDeadLine_Id bigint,
        Deadlines_EndDeadLine_Id bigint,
        primary key (id)
    );

    if object_id('Delegation_delegates', 'U') is null create table Delegation_delegates (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('Escalation', 'U') is null create table Escalation (
        id bigint identity not null,
        name varchar(255),
        Deadline_Escalation_Id bigint,
        primary key (id)
    );

    if object_id('EventTypes', 'U') is null create table EventTypes (
        InstanceId bigint not null,
        element varchar(255)
    );

    if object_id('I18NText', 'U') is null create table I18NText (
        id bigint identity not null,
        language varchar(255),
        shorttext varchar(255),
        text varchar(MAX),
        Task_Subjects_Id bigint,
        Task_Names_Id bigint,
        Task_Descriptions_Id bigint,
        Reassignment_Documentation_Id bigint,
        Notification_Subjects_Id bigint,
        Notification_Names_Id bigint,
        Notification_Documentation_Id bigint,
        Notification_Descriptions_Id bigint,
        Deadline_Documentation_Id bigint,
        primary key (id)
    );

    if object_id('NodeInstanceLog', 'U') is null create table NodeInstanceLog (
        id bigint identity not null,
        connection varchar(255),
        log_date datetime2,
        externalid varchar(255),
        nodeid varchar(255),
        nodeinstanceid varchar(255),
        nodename varchar(255),
        nodetype varchar(255),
        processid varchar(255),
        processinstanceid bigint not null,
        type int not null,
        workitemid bigint,
        primary key (id)
    );

    if object_id('Notification', 'U') is null create table Notification (
        DTYPE varchar(31) not null,
        id bigint identity not null,
        priority int not null,
        Escalation_Notifications_Id bigint,
        primary key (id)
    );

    if object_id('Notification_BAs', 'U') is null create table Notification_BAs (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('Notification_Recipients', 'U') is null create table Notification_Recipients (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('Notification_email_header', 'U') is null create table Notification_email_header (
        Notification_id bigint not null,
        emailheaders_id bigint not null,
        emailheaders_mapkey_key_mapkey varchar(255) not null,
        primary key (Notification_id, emailheaders_mapkey_key_mapkey)
    );

    if object_id('OrganizationalEntity', 'U') is null create table OrganizationalEntity (
        DTYPE varchar(31) not null,
        id varchar(255) not null,
        primary key (id)
    );

    if object_id('PeopleAssignments_BAs', 'U') is null create table PeopleAssignments_BAs (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('PeopleAssignments_ExclOwners', 'U') is null create table PeopleAssignments_ExclOwners (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('PeopleAssignments_PotOwners', 'U') is null create table PeopleAssignments_PotOwners (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('PeopleAssignments_Recipients', 'U') is null create table PeopleAssignments_Recipients (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('PeopleAssignments_Stakeholders', 'U') is null create table PeopleAssignments_Stakeholders (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('ProcessInstanceInfo', 'U') is null create table ProcessInstanceInfo (
        InstanceId bigint identity not null,
        lastmodificationdate datetime2,
        lastreaddate datetime2,
        processid varchar(255),
        processinstancebytearray varbinary(MAX),
        startdate datetime2,
        state int not null,
        OPTLOCK int,
        primary key (InstanceId)
    );

    if object_id('ProcessInstanceLog', 'U') is null create table ProcessInstanceLog (
        id bigint identity not null,
        duration bigint,
        end_date datetime2,
        externalid varchar(255),
        user_identity varchar(255),
        outcome varchar(255),
        parentprocessinstanceid bigint,
        processid varchar(255),
        processinstanceid bigint not null,
        processname varchar(255),
        processversion varchar(255),
        start_date datetime2,
        status int,
        primary key (id)
    );

    if object_id('Reassignment', 'U') is null create table Reassignment (
        id bigint identity not null,
        Escalation_Reassignments_Id bigint,
        primary key (id)
    );

    if object_id('Reassignment_potentialOwners', 'U') is null create table Reassignment_potentialOwners (
        task_id bigint not null,
        entity_id varchar(255) not null
    );

    if object_id('SessionInfo', 'U') is null create table SessionInfo (
        id int identity not null,
        lastmodificationdate datetime2,
        rulesbytearray varbinary(MAX),
        startdate datetime2,
        OPTLOCK int,
        primary key (id)
    );

    if object_id('Task', 'U') is null create table Task (
        id bigint identity not null,
        archived smallint,
        delegation_allowedtodelegate varchar(255),
        formname varchar(255),
        priority int not null,
        subtaskstrategy varchar(255),
        taskdata_activationtime datetime2,
        taskdata_createdon datetime2,
        taskdata_deploymentid varchar(255),
        taskdata_documentaccesstype int,
        taskdata_documentcontentid bigint not null,
        taskdata_documenttype varchar(255),
        taskdata_expirationtime datetime2,
        taskdata_faultaccesstype int,
        taskdata_faultcontentid bigint not null,
        taskdata_faultname varchar(255),
        taskdata_faulttype varchar(255),
        taskdata_outputaccesstype int,
        taskdata_outputcontentid bigint not null,
        taskdata_outputtype varchar(255),
        taskdata_parentid bigint not null,
        taskdata_previousstatus int,
        taskdata_processid varchar(255),
        taskdata_processinstanceid bigint not null,
        taskdata_processsessionid int not null,
        taskdata_skipable bit not null,
        taskdata_status varchar(255),
        taskdata_workitemid bigint not null,
        tasktype varchar(255),
        OPTLOCK int,
        peopl_assign_taskinitiator_id varchar(255),
        taskdata_actualowner_id varchar(255),
        taskdata_createdby_id varchar(255),
        primary key (id)
    );

    if object_id('TaskEvent', 'U') is null create table TaskEvent (
        id bigint identity not null,
        logtime datetime2,
        taskid bigint,
        type varchar(255),
        userid varchar(255),
        primary key (id)
    );

    if object_id('VariableInstanceLog', 'U') is null create table VariableInstanceLog (
        id bigint identity not null,
        log_date datetime2,
        externalid varchar(255),
        oldvalue varchar(255),
        processid varchar(255),
        processinstanceid bigint not null,
        value varchar(255),
        variableid varchar(255),
        variableinstanceid varchar(255),
        primary key (id)
    );

    if object_id('WorkItemInfo', 'U') is null create table WorkItemInfo (
        workitemid bigint identity not null,
        creationdate datetime2,
        name varchar(255),
        processinstanceid bigint not null,
        state bigint not null,
        OPTLOCK int,
        workitembytearray varbinary(MAX),
        primary key (workitemid)
    );

    if object_id('email_header', 'U') is null create table email_header (
        id bigint identity not null,
        body varchar(MAX),
        fromAddress varchar(255),
        language varchar(255),
        replyToAddress varchar(255),
        subject varchar(255),
        primary key (id)
    );

    if object_id('task_comment', 'U') is null create table task_comment (
        id bigint identity not null,
        addedat datetime2,
        text varchar(MAX),
        addedby_id varchar(255),
        TaskData_Comments_Id bigint,
        primary key (id)
    );

    if object_id('Attachment', 'U') is not null alter table Attachment 
        add constraint FK_9jaco4irrkskr5phh97x2fe9h 
        foreign key (attachedby_id) 
        references OrganizationalEntity;

    if object_id('Attachment', 'U') is not null alter table Attachment 
        add constraint FK_hqupx569krp0f0sgu9kh87513 
        foreign key (TaskData_Attachments_Id) 
        references Task;

    if object_id('BooleanExpression', 'U') is not null alter table BooleanExpression 
        add constraint FK_394nf2qoc0k9ok6omgd6jtpso 
        foreign key (Escalation_Constraints_Id) 
        references Escalation;

    if object_id('CorrelationPropertyInfo', 'U') is not null alter table CorrelationPropertyInfo 
        add constraint FK_1mgvtkn3h0bxu2fd657apkvxs 
        foreign key (correlationkey_keyId) 
        references CorrelationKeyInfo;

    if object_id('Deadline', 'U') is not null alter table Deadline 
        add constraint FK_68w742sge00vco2cq3jhbvmgx 
        foreign key (Deadlines_StartDeadLine_Id) 
        references Task;

    if object_id('Deadline', 'U') is not null alter table Deadline 
        add constraint FK_euoohoelbqvv94d8a8rcg8s5n 
        foreign key (Deadlines_EndDeadLine_Id) 
        references Task;

    if object_id('Delegation_delegates', 'U') is not null alter table Delegation_delegates 
        add constraint FK_gn7ula51sk55wj1o1m57guqxb 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('Delegation_delegates', 'U') is not null alter table Delegation_delegates 
        add constraint FK_fajq6kossbsqwr3opkrctxei3 
        foreign key (task_id) 
        references Task;

    if object_id('Escalation', 'U') is not null alter table Escalation 
        add constraint FK_ay2gd4fvl9yaapviyxudwuvfg 
        foreign key (Deadline_Escalation_Id) 
        references Deadline;

    if object_id('EventTypes', 'U') is not null alter table EventTypes 
        add constraint FK_nrecj4617iwxlc65ij6m7lsl1 
        foreign key (InstanceId) 
        references ProcessInstanceInfo;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_k16jpgrh67ti9uedf6konsu1p 
        foreign key (Task_Subjects_Id) 
        references Task;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_fd9uk6hemv2dx1ojovo7ms3vp 
        foreign key (Task_Names_Id) 
        references Task;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_4eyfp69ucrron2hr7qx4np2fp 
        foreign key (Task_Descriptions_Id) 
        references Task;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_pqarjvvnwfjpeyb87yd7m0bfi 
        foreign key (Reassignment_Documentation_Id) 
        references Reassignment;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_o84rkh69r47ti8uv4eyj7bmo2 
        foreign key (Notification_Subjects_Id) 
        references Notification;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_g1trxri8w64enudw2t1qahhk5 
        foreign key (Notification_Names_Id) 
        references Notification;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_qoce92c70adem3ccb3i7lec8x 
        foreign key (Notification_Documentation_Id) 
        references Notification;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_bw8vmpekejxt1ei2ge26gdsry 
        foreign key (Notification_Descriptions_Id) 
        references Notification;

    if object_id('I18NText', 'U') is not null alter table I18NText 
        add constraint FK_21qvifarxsvuxeaw5sxwh473w 
        foreign key (Deadline_Documentation_Id) 
        references Deadline;

    if object_id('Notification', 'U') is not null alter table Notification 
        add constraint FK_bdbeml3768go5im41cgfpyso9 
        foreign key (Escalation_Notifications_Id) 
        references Escalation;

    if object_id('Notification_BAs', 'U') is not null alter table Notification_BAs 
        add constraint FK_mfbsnbrhth4rjhqc2ud338s4i 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('Notification_BAs', 'U') is not null alter table Notification_BAs 
        add constraint FK_fc0uuy76t2bvxaxqysoo8xts7 
        foreign key (task_id) 
        references Notification;

    if object_id('Notification_Recipients', 'U') is not null alter table Notification_Recipients 
        add constraint FK_blf9jsrumtrthdaqnpwxt25eu 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('Notification_Recipients', 'U') is not null alter table Notification_Recipients 
        add constraint FK_3l244pj8sh78vtn9imaymrg47 
        foreign key (task_id) 
        references Notification;

    if object_id('Notification_email_header', 'U') is not null alter table Notification_email_header 
        add constraint UK_25vn3oqfsiwwda26w9uiprrwe unique (emailheaders_id);

    if object_id('Notification_email_header', 'U') is not null alter table Notification_email_header 
        add constraint FK_25vn3oqfsiwwda26w9uiprrwe 
        foreign key (emailheaders_id) 
        references email_header;

    if object_id('Notification_email_header', 'U') is not null alter table Notification_email_header 
        add constraint FK_eth4nvxn21fk1vnju85vkjrai 
        foreign key (Notification_id) 
        references Notification;

    if object_id('PeopleAssignments_BAs', 'U') is not null alter table PeopleAssignments_BAs 
        add constraint FK_t38xbkrq6cppifnxequhvjsl2 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('PeopleAssignments_BAs', 'U') is not null alter table PeopleAssignments_BAs 
        add constraint FK_omjg5qh7uv8e9bolbaq7hv6oh 
        foreign key (task_id) 
        references Task;

    if object_id('PeopleAssignments_ExclOwners', 'U') is not null alter table PeopleAssignments_ExclOwners 
        add constraint FK_pth28a73rj6bxtlfc69kmqo0a 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('PeopleAssignments_ExclOwners', 'U') is not null alter table PeopleAssignments_ExclOwners 
        add constraint FK_b8owuxfrdng050ugpk0pdowa7 
        foreign key (task_id) 
        references Task;

    if object_id('PeopleAssignments_PotOwners', 'U') is not null alter table PeopleAssignments_PotOwners 
        add constraint FK_tee3ftir7xs6eo3fdvi3xw026 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('PeopleAssignments_PotOwners', 'U') is not null alter table PeopleAssignments_PotOwners 
        add constraint FK_4dv2oji7pr35ru0w45trix02x 
        foreign key (task_id) 
        references Task;

    if object_id('PeopleAssignments_Recipients', 'U') is not null alter table PeopleAssignments_Recipients 
        add constraint FK_4g7y3wx6gnokf6vycgpxs83d6 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('PeopleAssignments_Recipients', 'U') is not null alter table PeopleAssignments_Recipients 
        add constraint FK_enhk831fghf6akjilfn58okl4 
        foreign key (task_id) 
        references Task;

    if object_id('PeopleAssignments_Stakeholders', 'U') is not null alter table PeopleAssignments_Stakeholders 
        add constraint FK_met63inaep6cq4ofb3nnxi4tm 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('PeopleAssignments_Stakeholders', 'U') is not null alter table PeopleAssignments_Stakeholders 
        add constraint FK_4bh3ay74x6ql9usunubttfdf1 
        foreign key (task_id) 
        references Task;

    if object_id('Reassignment', 'U') is not null alter table Reassignment 
        add constraint FK_pnpeue9hs6kx2ep0sp16b6kfd 
        foreign key (Escalation_Reassignments_Id) 
        references Escalation;

    if object_id('Reassignment_potentialOwners', 'U') is not null alter table Reassignment_potentialOwners 
        add constraint FK_8frl6la7tgparlnukhp8xmody 
        foreign key (entity_id) 
        references OrganizationalEntity;

    if object_id('Reassignment_potentialOwners', 'U') is not null alter table Reassignment_potentialOwners 
        add constraint FK_qbega5ncu6b9yigwlw55aeijn 
        foreign key (task_id) 
        references Reassignment;

    if object_id('Task', 'U') is not null alter table Task 
        add constraint FK_7hos7h1ft5wygyru9vm2mtp6b 
        foreign key (peopl_assign_taskinitiator_id) 
        references OrganizationalEntity;

    if object_id('Task', 'U') is not null alter table Task 
        add constraint FK_iu0slqdkjbb9mvikrns8mvqcg 
        foreign key (taskdata_actualowner_id) 
        references OrganizationalEntity;

    if object_id('Task', 'U') is not null alter table Task 
        add constraint FK_tek6betmy2fl0bnwrsx9a4fi9 
        foreign key (taskdata_createdby_id) 
        references OrganizationalEntity;

    if object_id('task_comment', 'U') is not null alter table task_comment 
        add constraint FK_fencp0rt8gae730n7621vqjre 
        foreign key (addedby_id) 
        references OrganizationalEntity;

    if object_id('task_comment', 'U') is not null alter table task_comment 
        add constraint FK_1ws9jdmhtey6mxu7jb0r0ufvs 
        foreign key (TaskData_Comments_Id) 
        references Task;